## ray 2.1.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6 )
set( CMAKE_CXX_COMPILER mpicxx )
set( CMAKE_CXX_FLAGS "-O3 -Wall -ansi" )
include_directories( RayPlatform code )
add_executable( Ray 
code/plugin_MachineHelper/MachineHelper.cpp
code/plugin_Library/Library.cpp
code/plugin_Library/LibraryPeakFinder.cpp
code/plugin_Library/LibraryWorker.cpp
code/plugin_FusionTaskCreator/FusionTaskCreator.cpp
code/plugin_FusionTaskCreator/FusionWorker.cpp
code/plugin_NetworkTest/NetworkTest.cpp
code/plugin_SequencesLoader/SequencesLoader.cpp
code/plugin_SequencesLoader/ArrayOfReads.cpp
code/plugin_SequencesLoader/ColorSpaceDecoder.cpp
code/plugin_SequencesLoader/FastqGzLoader.cpp
code/plugin_SequencesLoader/SffLoader.cpp
code/plugin_SequencesLoader/Read.cpp
code/plugin_SequencesLoader/FastaLoader.cpp
code/plugin_SequencesLoader/BzReader.cpp
code/plugin_SequencesLoader/FastqBz2Loader.cpp
code/plugin_SequencesLoader/Loader.cpp
code/plugin_SequencesLoader/FastqLoader.cpp
code/plugin_SequencesLoader/ColorSpaceLoader.cpp
code/plugin_VerticesExtractor/Vertex.cpp
code/plugin_VerticesExtractor/GridTable.cpp
code/plugin_VerticesExtractor/GridTableIterator.cpp
code/plugin_VerticesExtractor/VerticesExtractor.cpp
code/plugin_JoinerTaskCreator/JoinerTaskCreator.cpp
code/plugin_JoinerTaskCreator/JoinerWorker.cpp
code/plugin_SeedingData/SeedingData.cpp
code/plugin_SeedingData/SeedWorker.cpp
code/plugin_SeedingData/AssemblySeed.cpp
code/plugin_FusionData/FusionData.cpp
code/plugin_CoverageGatherer/CoverageGatherer.cpp
code/plugin_CoverageGatherer/CoverageDistribution.cpp
code/plugin_SeedExtender/Direction.cpp
code/plugin_SeedExtender/TipWatchdog.cpp
code/plugin_SeedExtender/Chooser.cpp
code/plugin_SeedExtender/ExtensionElement.cpp
code/plugin_SeedExtender/SeedExtender.cpp
code/plugin_SeedExtender/ExtensionData.cpp
code/plugin_SeedExtender/VertexMessenger.cpp
code/plugin_SeedExtender/ReadFetcher.cpp
code/plugin_SeedExtender/BubbleTool.cpp
code/plugin_SeedExtender/NovaEngine.cpp
code/plugin_SeedExtender/DepthFirstSearchData.cpp
code/plugin_SeedExtender/OpenAssemblerChooser.cpp
code/plugin_MessageProcessor/MessageProcessor.cpp
code/plugin_Partitioner/Partitioner.cpp
code/plugin_SequencesIndexer/SequencesIndexer.cpp
code/plugin_SequencesIndexer/PairedRead.cpp
code/plugin_SequencesIndexer/ReadAnnotation.cpp
code/plugin_SequencesIndexer/IndexerWorker.cpp
code/application_core/Parameters.cpp
code/application_core/ray_main.cpp
code/application_core/common_functions.cpp
code/application_core/Machine.cpp
code/plugin_Amos/Amos.cpp
code/plugin_KmerAcademyBuilder/Kmer.cpp
code/plugin_KmerAcademyBuilder/KmerAcademyBuilder.cpp
code/plugin_KmerAcademyBuilder/BloomFilter.cpp
code/plugin_EdgePurger/EdgePurger.cpp
code/plugin_EdgePurger/EdgePurgerWorker.cpp
code/plugin_Searcher/ColorSet.cpp
code/plugin_Searcher/ContigHit.cpp
code/plugin_Searcher/Searcher.cpp
code/plugin_Searcher/ContigSearchEntry.cpp
code/plugin_Searcher/VirtualKmerColor.cpp
code/plugin_Searcher/DistributionWriter.cpp
code/plugin_Searcher/ColoredPeakFinder.cpp
code/plugin_Searcher/QualityCaller.cpp
code/plugin_Searcher/SearchDirectory.cpp
code/plugin_Scaffolder/Scaffolder.cpp
code/plugin_Scaffolder/SummarizedLink.cpp
code/plugin_Scaffolder/ScaffoldingAlgorithm.cpp
code/plugin_Scaffolder/ScaffoldingVertex.cpp
code/plugin_Scaffolder/ScaffoldingEdge.cpp
code/plugin_Scaffolder/ScaffoldingLink.cpp
code/plugin_GeneOntology/KeyEncoder.cpp
code/plugin_GeneOntology/GeneOntology.cpp
code/plugin_GenomeNeighbourhood/GenomeNeighbourhood.cpp
code/plugin_GenomeNeighbourhood/NeighbourPair.cpp
code/plugin_GenomeNeighbourhood/Neighbour.cpp
code/plugin_PhylogenyViewer/GenomeToTaxonLoader.cpp
code/plugin_PhylogenyViewer/PhylogenyViewer.cpp
code/plugin_PhylogenyViewer/PhylogeneticTreeLoader.cpp
code/plugin_PhylogenyViewer/TaxonNameLoader.cpp
RayPlatform/handlers/MasterModeExecutor.cpp
RayPlatform/handlers/SlaveModeExecutor.cpp
RayPlatform/handlers/MessageTagExecutor.cpp
RayPlatform/core/master_modes.cpp
RayPlatform/core/ComputeCore.cpp
RayPlatform/core/slave_modes.cpp
RayPlatform/core/OperatingSystem.cpp
RayPlatform/core/statistics.cpp
RayPlatform/routing/GraphImplementationExperimental.cpp
RayPlatform/routing/GraphImplementationKautz.cpp
RayPlatform/routing/ConnectionGraph.cpp
RayPlatform/routing/GraphImplementation.cpp
RayPlatform/routing/GraphImplementationGroup.cpp
RayPlatform/routing/GraphImplementationComplete.cpp
RayPlatform/routing/GraphImplementationDeBruijn.cpp
RayPlatform/routing/GraphImplementationRandom.cpp
RayPlatform/routing/Hypercube.cpp
RayPlatform/scheduling/TaskCreator.cpp
RayPlatform/scheduling/SwitchMan.cpp
RayPlatform/scheduling/VirtualProcessor.cpp
RayPlatform/profiling/Derivative.cpp
RayPlatform/profiling/TimePrinter.cpp
RayPlatform/profiling/Profiler.cpp
RayPlatform/profiling/TickLogger.cpp
RayPlatform/cryptography/crypto.cpp
RayPlatform/structures/StaticVector.cpp
RayPlatform/memory/ReusableMemoryStore.cpp
RayPlatform/memory/ChunkAllocatorWithDefragmentation.cpp
RayPlatform/memory/DefragmentationGroup.cpp
RayPlatform/memory/RingAllocator.cpp
RayPlatform/memory/MyAllocator.cpp
RayPlatform/memory/allocator.cpp
RayPlatform/memory/DefragmentationLane.cpp
RayPlatform/plugins/CorePlugin.cpp
RayPlatform/plugins/RegisteredPlugin.cpp
RayPlatform/communication/VirtualCommunicator.cpp
RayPlatform/communication/MessagesHandler.cpp
RayPlatform/communication/MessageRouter.cpp
RayPlatform/communication/Message.cpp
RayPlatform/communication/mpi_tags.cpp
RayPlatform/communication/BufferedData.cpp
)

=== Makefile ===
VERSION = 2
PATCHLEVEL = 1
SUBLEVEL = 0
EXTRAVERSION =
NAME = Ancient Granularity of Epochs

# number of cores to use for compilation
J=1

RAY_VERSION = $(VERSION).$(PATCHLEVEL).$(SUBLEVEL)$(EXTRAVERSION)

# author: Sébastien Boisvert
# Makefile for the ray assembler
# Objects appended to obj-y are compiled and linked.
# Objects appended to obj-n are not compiled and linked.
#############################################
# compilation options

# installation prefix with make install
PREFIX=install-prefix

# maximum k-mer length
# in nucleotides
# 32 nucleotides are stored on 1x64 bits
# 45 nucleotides are stored on 2x64 bits
# 64 nucleotides are stored on 2x64 bits
# 96 nucleotides are stored on 3x64 bits
# Intermediate values should utilise intermediate numbers of bits.
# There is no maximum value for MAXKMERLENGTH
MAXKMERLENGTH = 32

# support for .gz files
# needs libz
# set to no if you don't have libz
# y/n
HAVE_LIBZ = n

# support for .bz2 files
# needs libbz2
# set to no if you don't have libbz2
# y/n
HAVE_LIBBZ2 = n

# use Intel's compiler
# the name of the Intel MPI C++ compiler is mpiicpc
# Open-MPI and MPICH2 utilise mpic++ for the name.
# y/n
INTEL_COMPILER = n

# pack structures to reduce memory usage
# will work on x86 and x86_64
# won't work on Itanium and on Sparc
# The operating system's kernel must also allow the retrieval of 8-byte chunks sitting
# between two memory cache pages. Linux can do that, but I don't know for others.
# if you are not sure, type uname -a to get your processor architecture.
#
# Seems to fail or be very slow on Intel Xeon too.
#
# y/n
FORCE_PACKING = n

# compile assertions
# Ray may be faster when ASSERT=n
# y/n
ASSERT = n

# collect profiling information with -run-profiler
# if set to n, the code is not even compiled in
CONFIG_PROFILER_COLLECT=n

# use the precision clock
# needs -l rt too
CONFIG_CLOCK_GETTIME=n

# OS detection based on git Makefile
uname_S := $(shell sh -c 'uname -s 2>/dev/null || echo not')

# optimize
OPTIMIZE = y

# add -g to gcc
# see "Is there a downside to leaving in debug symbols in release builds?"
# http://stackoverflow.com/questions/5569644/is-there-a-downside-to-leaving-in-debug-symbols-in-release-builds
# in short: the executable is larger, but symbols are in a different section (thus the code is not slower)
DEBUG = n

# profiling
GPROF = n

ifeq ($(GPROF),y)
	OPTIMIZE = n
	FORCE_PACKING = n
endif

PEDANTIC = n

MPICXX-y = mpicxx

# mpic++ from an MPI implementation must be reachable with the PATH
# tested implementations of MPI include Open-MPI and MPICH2
CXXFLAGS = 

# optimization
CXXFLAGS-$(OPTIMIZE) += -O3

ifeq ($(INTEL_COMPILER),n)
# g++ options
ifeq ($(uname_S),Linux)
	#-std=c++98
	CXXFLAGS += -Wall -std=c++98
	CXXFLAGS-$(PEDANTIC) += -pedantic -Wextra 
endif
endif

# profiling
CXXFLAGS-$(GPROF) += -g -pg
LDFLAGS-$(GPROF) += -pg -g

# if you use Intel's mpiicpc, uncomment the following lines
MPICXX-$(INTEL_COMPILER) = mpiicpc 
CXXFLAGS-$(INTEL_COMPILER) += -DMPICH_IGNORE_CXX_SEEK -DMPICH_SKIP_MPICXX

#maximum k-mer length
CXXFLAGS-y += -D MAXKMERLENGTH=$(MAXKMERLENGTH)
CXXFLAGS-y += $(EXTRA)
LDFLAGS-y += $(EXTRA)

# compile assertions
CXXFLAGS-$(ASSERT) += -DASSERT

#compile with libz
CXXFLAGS-$(HAVE_LIBZ) += -DHAVE_LIBZ
LDFLAGS-$(HAVE_LIBZ) += -lz

#compile with libbz2
CXXFLAGS-$(HAVE_LIBBZ2) += -DHAVE_LIBBZ2 
LDFLAGS-$(HAVE_LIBBZ2) += -lbz2

#debug flag
CXXFLAGS-$(DEBUG) += -g
LDFLAGS-$(DEBUG)  += -g

# pack data in memory to save space
CXXFLAGS-$(FORCE_PACKING) += -DFORCE_PACKING

CXXFLAGS-$(CONFIG_PROFILER_COLLECT) += -D CONFIG_PROFILER_COLLECT
CXXFLAGS-$(CONFIG_CLOCK_GETTIME) += -D CONFIG_CLOCK_GETTIME
LDFLAGS-$(CONFIG_CLOCK_GETTIME) += -l rt
CXXFLAGS-y += -D RAY_VERSION=\\\"$(RAY_VERSION)\\\"

CXXFLAGS += $(CXXFLAGS-y)
LDFLAGS += $(LDFLAGS-y)

MPICXX = $(MPICXX-y)

# object files

#################################


# the target is Ray
all: Ray

showOptions: 
	@echo ""
	@echo "Compilation options (you can change them of course)"
	@echo ""
	@echo PREFIX = $(PREFIX)
	@echo MAXKMERLENGTH = $(MAXKMERLENGTH)
	@echo FORCE_PACKING = $(FORCE_PACKING)
	@echo ASSERT = $(ASSERT)
	@echo HAVE_LIBZ = $(HAVE_LIBZ)
	@echo HAVE_LIBBZ2 = $(HAVE_LIBBZ2)
	@echo INTEL_COMPILER = $(INTEL_COMPILER)
	@echo MPICXX = $(MPICXX)
	@echo GPROF = $(GPROF)
	@echo OPTIMIZE = $(OPTIMIZE)
	@echo DEBUG = $(DEBUG)
	@echo ""
	@echo "Compilation and linking flags (generated automatically)"
	@echo ""
	@echo CXXFLAGS = $(CXXFLAGS)
	@echo LDFLAGS = $(LDFLAGS)
	@echo ""
	@touch showOptions
	
# how to make Ray
Ray: showOptions RayPlatform/libRayPlatform.a code/TheRayGenomeAssembler.a
	$(MPICXX) $(LDFLAGS)  code/TheRayGenomeAssembler.a RayPlatform/libRayPlatform.a -o $@
	@echo $(PREFIX) > PREFIX
	@echo Ray > TARGETS

code/TheRayGenomeAssembler.a:
	@cd code; make MPICXX="$(MPICXX)" CXXFLAGS="$(CXXFLAGS)" -j $(J) all ; cd ..

RayPlatform/libRayPlatform.a:
	@cd RayPlatform; make MPICXX="$(MPICXX)" CXXFLAGS="$(CXXFLAGS)" -j $(J) ; cd ..

clean:
	@rm -f Ray showOptions PREFIX TARGETS
	@echo "Cleaning Ray Application"
	@(cd code; make clean; cd ..)
	@echo "Cleaning Ray Platform"
	@cd RayPlatform;make clean; cd ..
	@echo CLEAN

install: 
	@scripts/install.sh

=== RayPlatform/Makefile ===
# author: Sébastien Boisvert
#
# based on http://www.ravnborg.org/kbuild/makefiles.html
#

VERSION = 1
PATCHLEVEL = 1
SUBLEVEL = 0
EXTRAVERSION = 
NAME = Chariot of Complexity

RAYPLATFORM_VERSION = $(VERSION).$(PATCHLEVEL).$(SUBLEVEL)$(EXTRAVERSION)

include common.mk

all: libRayPlatform.a

libRayPlatform.a: $(obj-y)
	$(AR) rcs $@ $^

# inference rule
%.o: %.cpp
	$(MPICXX) $(CXXFLAGS) -D RAYPLATFORM_VERSION=\"$(RAYPLATFORM_VERSION)\" -I. -c -o $@ $<

clean:
	$(RM) -f libRayPlatform.a $(obj-y)

=== code/Makefile ===
# author Sébastien Boisvert
#
# based on http://www.ravnborg.org/kbuild/makefiles.html
#
# the code is distributed in a small Ray core that is built on top
# of the Ray platform.
#
# Then, plugins (interface CorePlugin in the Ray Platform)
# are simply added onto the core (class ComputeCore in the
# Ray Platform).

MPICXX = mpicxx
LD = ld
AR = ar
RM = rm
CXXFLAGS= -O3 -Wall -ansi

TARGET=TheRayGenomeAssembler.a

all: $(TARGET) 

include application_core/Makefile
include plugin_*/Makefile

$(TARGET): $(obj-y)
	$(AR) rcs $@ $^

# inference rule
%.o: %.cpp
	$(MPICXX) $(CXXFLAGS) -I ../RayPlatform -I. -c -o $@ $<

clean:
	$(RM) -f ray_core.o $(PLUGINS-y) $(obj-y) $(TARGET)

=== code/application_core/Makefile ===

application_core-y += application_core/ray_main.o application_core/Machine.o 
application_core-y += application_core/Parameters.o application_core/common_functions.o

obj-y += $(application_core-y)

=== code/plugin_Amos/Makefile ===

Amos-y += plugin_Amos/Amos.o

obj-y += $(Amos-y)

=== code/plugin_CoverageGatherer/Makefile ===

CoverageGatherer-y += plugin_CoverageGatherer/CoverageGatherer.o 
CoverageGatherer-y += plugin_CoverageGatherer/CoverageDistribution.o 

obj-y += $(CoverageGatherer-y)

=== code/plugin_EdgePurger/Makefile ===
# plugin EdgePurger

EdgePurger-y += plugin_EdgePurger/EdgePurger.o plugin_EdgePurger/EdgePurgerWorker.o

obj-y += $(EdgePurger-y)

=== code/plugin_FusionData/Makefile ===

FusionData-y += plugin_FusionData/FusionData.o 

obj-y += $(FusionData-y)

=== code/plugin_FusionTaskCreator/Makefile ===

FusionTaskCreator-y += plugin_FusionTaskCreator/FusionWorker.o 
FusionTaskCreator-y += plugin_FusionTaskCreator/FusionTaskCreator.o 

obj-y += $(FusionTaskCreator-y)

=== code/plugin_GeneOntology/Makefile ===

GeneOntology-y += plugin_GeneOntology/KeyEncoder.o
GeneOntology-y += plugin_GeneOntology/GeneOntology.o

obj-y += $(GeneOntology-y)

=== code/plugin_GenomeNeighbourhood/Makefile ===
# this file contains the blueprints for
# the plugin GenomeNeighbourhood
# \author Sébastien Boisvert
# \date 2012-03-20 initial version

GenomeNeighbourhood-y += plugin_GenomeNeighbourhood/GenomeNeighbourhood.o
GenomeNeighbourhood-y += plugin_GenomeNeighbourhood/Neighbour.o
GenomeNeighbourhood-y += plugin_GenomeNeighbourhood/NeighbourPair.o

obj-y += $(GenomeNeighbourhood-y)

=== debian/changelog ===
ray (2.1.0-1) unstable; urgency=low

  * Initial Debian release, Closes: #692238

 -- Sébastien Boisvert <sebastien.boisvert.3@ulaval.ca>  Fri, 14 Nov 2012 13:32:00 +0000

=== debian/control ===
Source: ray
Section: science
Priority: extra
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Sébastien Boisvert <sebastien.boisvert.3@ulaval.ca>,
           Tim Booth <tbooth@ceh.ac.uk>
Build-Depends: debhelper (>= 9),
	zlib1g-dev,
	libbz2-dev,
	mpi-default-dev
Standards-Version: 3.9.3
Homepage: http://denovoassembler.sourceforge.net/
Vcs-Git: git://git.debian.org/git/debian-med/ray.git
Vcs-Browser: http://git.debian.org/?p=debian-med/ray.git

Package: ray
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
	mpi-default-bin
Description: parallel genome assemblies for parallel DNA sequencing
 Ray is a parallel software that computes de novo genome assemblies with   
 next-generation sequencing data.
 Ray is written in C++ and can run in parallel on numerous interconnected 
 computers using the message-passing interface (MPI) standard.
 Included:
  - Ray de novo assembly of single genomes
  - Ray Méta de novo assembly of metagenomes
  - Ray Communities microbe abundance + taxonomic profiling
  - Ray Ontologies gene ontology profiling

Package: ray-doc
Section: doc
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Documentation files
 Ray is a parallel software that computes de novo genome assemblies with   
 next-generation sequencing data.
 Ray is written in C++ and can run in parallel on numerous interconnected 
 computers using the message-passing interface (MPI) standard.
 This sub-package includes documentation files.

Package: ray-extra
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends},
  ${python:Depends}, r-base-core, python
Description: Scripts and XSL sheets for post-processing
 Ray is a parallel software that computes de novo genome assemblies with   
 next-generation sequencing data.
 Ray is written in C++ and can run in parallel on numerous interconnected 
 computers using the message-passing interface (MPI) standard.
 This sub-package contains scripts and XSL sheets for post-processing.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

CPPFLAGS=$(shell dpkg-buildflags --get CPPFLAGS)
CXXFLAGS=$(shell dpkg-buildflags --get CXXFLAGS)
CXXFLAGS+=$(CPPFLAGS)
CXXFLAGS+=-I. -I../RayPlatform -DHAVE_LIBZ -DHAVE_LIBBZ2 
CXXFLAGS+=-DRAY_VERSION=\\\\\\\"2.1.0\\\\\\\" 

%:
	dh $@ 

override_dh_auto_clean :
	dh_auto_clean -- HAVE_LIBZ=y HAVE_LIBBZ2=y
	rm -rf install-prefix
	rm -f README.Ray  README.RayPlatform

override_dh_auto_build :
	dh_auto_build -- CXXFLAGS="$(CXXFLAGS)" HAVE_LIBBZ2=y HAVE_LIBZ=y
	#Rename 2 docs to make more sence in package context
	cp README.md README.Ray
	cp RayPlatform/README README.RayPlatform

=== debian/watch ===
version=3
http://sf.net/denovoassembler/Ray-v(.+)\.tar\.bz2

## ray 2.3.0

=== Makefile ===
VERSION = 2
PATCHLEVEL = 3
SUBLEVEL = 0
EXTRAVERSION =
NAME = Distributed Pumpkin

# Like in Linux, stuff that must be propagated to
# the source code (C++ here) or other Makefiles
# are prefixed with CONFIG_

# author: Sébastien Boisvert
# Makefile for the ray assembler
# Objects appended to obj-y are compiled and linked.
# Objects appended to obj-n are not compiled and linked.
#
# Based on http://www.ravnborg.org/kbuild/makefiles.html
#
# The code is distributed in a small Ray core that is built on top
# of the RayPlatform.
#
# Then, plugins (interface CorePlugin in the RayPlatform)
# are simply added onto the core (class ComputeCore in the
# RayPlatform).

# this can be changed with make MPICXX=...
MPICXX = mpicxx

# CXXFLAGS can be changed by the end user with make CXXFLAGS="..."
CXXFLAGS = -O3 -std=c++98 -Wall -g

RM = rm
CD = cd
MAKE = make
ECHO = echo
MKDIR = mkdir
CP = cp

CONFIG_RAY_VERSION = $(VERSION).$(PATCHLEVEL).$(SUBLEVEL)$(EXTRAVERSION)

#######################################################################
# Compilation options
#######################################################################

# installation prefix with make install
PREFIX=install-prefix

# maximum k-mer length
# in nucleotides
# 32 nucleotides are stored on 1x64 bits
# 45 nucleotides are stored on 2x64 bits
# 64 nucleotides are stored on 2x64 bits
# 96 nucleotides are stored on 3x64 bits
# Intermediate values should utilise intermediate numbers of bits.
# There is no maximum value for MAXKMERLENGTH
MAXKMERLENGTH = 32

# support for .gz files
# needs libz
# set to no if you don't have libz
# y/n
HAVE_LIBZ = n

# support for .bz2 files
# needs libbz2
# set to no if you don't have libbz2
# y/n
HAVE_LIBBZ2 = n

# pack structures to reduce memory usage
# will work on x86 and x86_64
# won't work on Itanium and on Sparc
# The operating system's kernel must also allow the retrieval of 8-byte chunks sitting
# between two memory cache pages. Linux can do that, but I don't know for others.
# if you are not sure, type uname -a to get your processor architecture.
#
# Seems to fail or be very slow on Intel Xeon too.
#
# y/n
FORCE_PACKING = n

# compile assertions
# Ray may be faster when ASSERT=n
# y/n
ASSERT = n

# collect profiling information with -run-profiler
# if set to n, the code is not even compiled in
PROFILER_COLLECT=n

# use the precision clock
# needs -l rt too
CLOCK_GETTIME=n

# use MPI I/O for file operations

MPI_IO=n

#######################################################################
# Don't edit below this this point ---> .
#######################################################################

# Build configuration options correctly for the source code

CONFIG_ASSERT=$(ASSERT)
CONFIG_HAVE_LIBZ=$(HAVE_LIBZ)
CONFIG_HAVE_LIBBZ2=$(HAVE_LIBBZ2)
CONFIG_FORCE_PACKING=$(FORCE_PACKING)
CONFIG_PROFILER_COLLECT=$(PROFILER_COLLECT)
CONFIG_CLOCK_GETTIME=$(CLOCK_GETTIME)
CONFIG_MPI_IO=$(MPI_IO)

# These 2 are used by an other Makefile
export CONFIG_HAVE_LIBZ
export CONFIG_HAVE_LIBBZ2

#######################################################################

# Build the CONFIG_FLAGS
# This could be stored in a config.h too.
CONFIG_FLAGS-y=

#maximum k-mer length
CONFIG_FLAGS-y += -D CONFIG_MAXKMERLENGTH=$(MAXKMERLENGTH)

# compile assertions
CONFIG_FLAGS-$(CONFIG_ASSERT) += -D CONFIG_ASSERT -D ASSERT

#compile with zlib
CONFIG_FLAGS-$(CONFIG_HAVE_LIBZ) += -D CONFIG_HAVE_LIBZ
LDFLAGS-$(CONFIG_HAVE_LIBZ) += -lz

#compile with libbz2
CONFIG_FLAGS-$(CONFIG_HAVE_LIBBZ2) += -D CONFIG_HAVE_LIBBZ2
LDFLAGS-$(CONFIG_HAVE_LIBBZ2) += -lbz2

# pack data in memory to save space
CONFIG_FLAGS-$(CONFIG_FORCE_PACKING) += -D CONFIG_FORCE_PACKING

# use MPI I/O
CONFIG_FLAGS-$(CONFIG_MPI_IO) += -D CONFIG_MPI_IO
CONFIG_FLAGS-$(CONFIG_PROFILER_COLLECT) += -D CONFIG_PROFILER_COLLECT
CONFIG_FLAGS-$(CONFIG_CLOCK_GETTIME) += -D CONFIG_CLOCK_GETTIME
LDFLAGS-$(CONFIG_CLOCK_GETTIME) += -l rt
CONFIG_FLAGS-y += -D CONFIG_RAY_VERSION=\"$(CONFIG_RAY_VERSION)\"

# CONFIG_FLAGS is separate from CXXFLAGS
# This eases building the package in distributions
LDFLAGS = $(LDFLAGS-y)
CONFIG_FLAGS=$(CONFIG_FLAGS-y)

Q=@

#######################################################################
# Build rules.
# the target is Ray
all: Ray

# inference rule
%.o: %.cpp
	$(Q)$(ECHO) "  CXX $@"
	$(Q)$(MPICXX) $(CXXFLAGS) $(CONFIG_FLAGS) -I. -IRayPlatform -c $< -o $@

include code/*/Makefile

showOptions:
	$(Q)echo ""
	$(Q)echo "Compilation options (you can change them of course)"
	$(Q)echo ""
	$(Q)echo PREFIX = $(PREFIX)
	$(Q)echo MPICXX = $(MPICXX)
	$(Q)echo MAXKMERLENGTH = $(MAXKMERLENGTH)
	$(Q)echo FORCE_PACKING = $(FORCE_PACKING)
	$(Q)echo ASSERT = $(ASSERT)
	$(Q)echo HAVE_LIBZ = $(HAVE_LIBZ)
	$(Q)echo HAVE_LIBBZ2 = $(HAVE_LIBBZ2)
	$(Q)echo ""
	$(Q)echo "Compilation and linking flags (generated automatically)"
	$(Q)echo ""
	$(Q)echo CXXFLAGS = $(CXXFLAGS)
	$(Q)echo CONFIG_FLAGS = $(CONFIG_FLAGS)
	$(Q)echo LDFLAGS = $(LDFLAGS)
	$(Q)echo ""
	$(Q)touch showOptions
	
# how to make Ray
Ray: code/application_core/ray_main.o libRay.a libRayPlatform.a
	$(Q)$(ECHO) "  LD $@"
	$(Q)$(MPICXX) $^ -o$@ $(LDFLAGS)
	$(Q)$(ECHO) $(PREFIX) > PREFIX

libRay.a: $(obj-y)
	$(Q)$(ECHO) "  AR $@"
	$(Q)$(AR) rcs $@ $^

libRayPlatform.a: RayPlatform/libRayPlatform.a
	$(Q)$(CP) $^ $@

RayPlatform/libRayPlatform.a:
	$(Q)$(MAKE) $(MFLAGS) -C RayPlatform

clean:
	$(Q)$(MAKE) $(MFLAGS) -C RayPlatform clean
	$(Q)$(ECHO) CLEAN Ray plugins
	$(Q)$(RM) -f Ray PREFIX $(obj-y) libRay.a libRayPlatform.a code/application_core/ray_main.o

install:
	$(eval PREFIX=$(shell cat PREFIX))

	$(Q)$(MKDIR) -p $(PREFIX)

	$(Q)$(ECHO) ""
	$(Q)$(ECHO) "Installing Ray to $(PREFIX)"
	$(Q)$(ECHO) ""

	$(Q)cp LICENSE.txt $(PREFIX)
	$(Q)cp gpl-3.0.txt $(PREFIX)
	$(Q)cp RayPlatform/lgpl-3.0.txt $(PREFIX)

	$(Q)cp Ray $(PREFIX)
	$(Q)cp -r Documentation $(PREFIX)
	$(Q)cp README.md $(PREFIX)
	$(Q)cp MANUAL_PAGE.txt $(PREFIX)
	$(Q)cp AUTHORS $(PREFIX)
	$(Q)cp -r scripts $PREFIX

	$(Q)mkdir $(PREFIX)/RayPlatform
	$(Q)cp RayPlatform/AUTHORS $(PREFIX)/RayPlatform
	$(Q)cp RayPlatform/README $(PREFIX)/RayPlatform
	$(Q)cp -r RayPlatform/Documentation $(PREFIX)/RayPlatform

=== RayPlatform/Makefile ===
# author: Sébastien Boisvert
#
# based on http://www.ravnborg.org/kbuild/makefiles.html
#

VERSION = 2
PATCHLEVEL = 0
SUBLEVEL = 0
EXTRAVERSION =
NAME =  Actor Nest

RAYPLATFORM_VERSION = $(VERSION).$(PATCHLEVEL).$(SUBLEVEL)$(EXTRAVERSION)

include common.mk

all: libRayPlatform.a

libRayPlatform.a: $(obj-y)
	$(Q)$(ECHO) "  AR $@"
	$(Q)$(AR) rcs $@ $^

# compile assertions

CONFIG_ASSERT=$(ASSERT)

CONFIG_FLAGS-y=
CONFIG_FLAGS-$(CONFIG_ASSERT) += -D CONFIG_ASSERT -D ASSERT
CONFIG_FLAGS=$(CONFIG_FLAGS-y)

# inference rule
%.o: %.cpp
	$(Q)$(ECHO) "  CXX $@"
	$(Q)$(MPICXX) $(CXXFLAGS) $(CONFIG_FLAGS) -D RAYPLATFORM_VERSION=\"$(RAYPLATFORM_VERSION)\" -I. -c -o $@ $<

clean:
	$(Q)$(ECHO) CLEAN RayPlatform
	$(Q)$(RM) -f libRayPlatform.a $(obj-y)

=== code/FusionTaskCreator/Makefile ===
FusionTaskCreator-y += code/FusionTaskCreator/FusionWorker.o 
FusionTaskCreator-y += code/FusionTaskCreator/FusionTaskCreator.o 

obj-y += $(FusionTaskCreator-y)

=== code/Scaffolder/Makefile ===
Scaffolder-y += code/Scaffolder/Scaffolder.o 
Scaffolder-y += code/Scaffolder/ScaffoldingLink.o
Scaffolder-y += code/Scaffolder/SummarizedLink.o
Scaffolder-y += code/Scaffolder/ScaffoldingAlgorithm.o
Scaffolder-y += code/Scaffolder/ScaffoldingVertex.o
Scaffolder-y += code/Scaffolder/ScaffoldingEdge.o

obj-y += $(Scaffolder-y)

=== code/application_core/Makefile ===
#application_core-y += code/application_core/ray_main.o
application_core-y += code/application_core/Machine.o 

obj-y += $(application_core-y)

=== debian/changelog ===
ray (2.3.0-2) unstable; urgency=medium

  * Fix Build issue on mips, mipsel and s390x (thanks for the patch
    to Aurelien Jarno <aurel32@debian.org>)
    Closes: #739184
  * Added myself as Uploader

 -- Andreas Tille <tille@debian.org>  Sun, 16 Feb 2014 22:36:57 +0100

ray (2.3.0-1) unstable; urgency=low

  [ Sébastien Boisvert ]
  * New upstream version
     (previous patches removed since applied upstream)

  [ Andreas Tille ]
  * debian/control:
     - Priority should be optional
     - enhanced description
     - normalised d/control via `cme fix dpkg-control`
  * debian/watch: More precise regexp to fit also historic versions
  * debian/upstream: publication information
  * debian/Ray.1: Enhanced formatting
  * debian/patches/hardening.patch: Propagate hardening options

 -- Sébastien Boisvert <sebastien.boisvert.3@ulaval.ca>  Mon, 3 Feb 2014 13:17:00 -0500

=== debian/control ===
Source: ray
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Sébastien Boisvert <sebastien.boisvert.3@ulaval.ca>,
           Andreas Tille <tille@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper (>= 9),
               zlib1g-dev,
               libbz2-dev,
               mpi-default-dev
Standards-Version: 3.9.5
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-med/ray.git
Vcs-Git: git://anonscm.debian.org/debian-med/ray.git
Homepage: http://denovoassembler.sourceforge.net/

Package: ray
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         mpi-default-bin
Description: parallel de novo genome assemblies of next-gen sequencing data
 Ray is a parallel software that computes de novo genome assemblies with   
 next-generation sequencing data.
 Ray is written in C++ and can run in parallel on numerous interconnected 
 computers using the message-passing interface (MPI) standard.
 Included:
  - Ray de novo assembly of single genomes
  - Ray Méta de novo assembly of metagenomes
  - Ray Communities microbe abundance + taxonomic profiling
  - Ray Ontologies gene ontology profiling

Package: ray-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Description: focumentation for ray parallel de novo genome assembler
 Ray is a parallel software that computes de novo genome assemblies with   
 next-generation sequencing data.
 Ray is written in C++ and can run in parallel on numerous interconnected 
 computers using the message-passing interface (MPI) standard.
 .
 This package includes documentation files.

Package: ray-extra
Architecture: all
Depends: ${misc:Depends},
         r-base-core,
         python
Description: Scripts and XSL sheets for post-processing for ray de novo assembler
 Ray is a parallel software that computes de novo genome assemblies with   
 next-generation sequencing data.
 Ray is written in C++ and can run in parallel on numerous interconnected 
 computers using the message-passing interface (MPI) standard.
 .
 This package contains scripts and XSL sheets for post-processing.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@ 

override_dh_auto_clean :
	dh_auto_clean -- CXXFLAGS="$(CXXFLAGS)" HAVE_LIBZ=y HAVE_LIBBZ2=y
	rm -rf install-prefix
	rm -f README.Ray  README.RayPlatform

override_dh_auto_build :
	dh_auto_build -- CXXFLAGS="$(CXXFLAGS)" DEBLDFLAGS="$(LDFLAGS)" HAVE_LIBBZ2=y HAVE_LIBZ=y
	#Rename 2 docs to make more sence in package context
	cp README.md README.Ray
	cp RayPlatform/README.md README.RayPlatform
	cp RayPlatform/README.md RayPlatform/README

## ray 2.3.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6 )
set( CMAKE_CXX_COMPILER mpicxx )
set( CMAKE_CXX_FLAGS "-O3 -Wall -std=c++98 -g" )
include_directories( . RayPlatform )
add_executable( Ray 



code/application_core/ray_main.cpp
code/application_core/Machine.cpp
code/Partitioner/Partitioner.cpp
code/Searcher/DistributionWriter.cpp
code/Searcher/Searcher.cpp
code/Searcher/ContigHit.cpp
code/Searcher/ContigSearchEntry.cpp
code/Searcher/SearchDirectory.cpp
code/Searcher/ColorSet.cpp
code/Searcher/VirtualKmerColor.cpp
code/Searcher/QualityCaller.cpp
code/Searcher/ColoredPeakFinder.cpp
code/KmerAcademyBuilder/KmerAcademyBuilder.cpp
code/KmerAcademyBuilder/Kmer.cpp
code/KmerAcademyBuilder/BloomFilter.cpp
code/SequencesLoader/BzReader.cpp
code/SequencesLoader/FastaGzLoader.cpp
code/SequencesLoader/ExportLoader.cpp
code/SequencesLoader/LoaderFactory.cpp
code/SequencesLoader/FastqLoader.cpp
code/SequencesLoader/FastqGzLoader.cpp
code/SequencesLoader/LoaderInterface.cpp
code/SequencesLoader/FastaBz2Loader.cpp
code/SequencesLoader/SffLoader.cpp
code/SequencesLoader/FastaLoader.cpp
code/SequencesLoader/ColorSpaceLoader.cpp
code/SequencesLoader/Loader.cpp
code/SequencesLoader/ColorSpaceDecoder.cpp
code/SequencesLoader/FastqBz2Loader.cpp
code/SequencesLoader/ArrayOfReads.cpp
code/SequencesLoader/BufferedReader.cpp
code/SequencesLoader/ReadHandle.cpp
code/SequencesLoader/FastaLoaderForReads.cpp
code/SequencesLoader/SequenceFileDetector.cpp
code/SequencesLoader/Read.cpp
code/SequencesLoader/SequencesLoader.cpp
code/JoinerTaskCreator/JoinerTaskCreator.cpp
code/JoinerTaskCreator/JoinerWorker.cpp
code/SeedExtender/ExtensionElement.cpp
code/SeedExtender/ReadFetcher.cpp
code/SeedExtender/OpenAssemblerChooser.cpp
code/SeedExtender/VertexMessenger.cpp
code/SeedExtender/TipWatchdog.cpp
code/SeedExtender/NovaEngine.cpp
code/SeedExtender/BubbleTool.cpp
code/SeedExtender/Chooser.cpp
code/SeedExtender/SeedExtender.cpp
code/SeedExtender/Direction.cpp
code/SeedExtender/ExtensionData.cpp
code/SeedExtender/DepthFirstSearchData.cpp
code/Library/Library.cpp
code/Library/LibraryWorker.cpp
code/Library/LibraryPeakFinder.cpp
code/Mock/Mock.cpp
code/Mock/Parameters.cpp
code/Mock/common_functions.cpp
code/Example/Example.cpp
code/TaxonomyViewer/TaxonomyViewer.cpp
code/TaxonomyViewer/TaxonomicTreeLoader.cpp
code/TaxonomyViewer/TaxonNameLoader.cpp
code/TaxonomyViewer/GenomeToTaxonLoader.cpp
code/GeneOntology/KeyEncoder.cpp
code/GeneOntology/GeneOntology.cpp
code/MessageProcessor/MessageProcessor.cpp
code/PathEvaluator/PathEvaluator.cpp
code/VerticesExtractor/VerticesExtractor.cpp
code/VerticesExtractor/Vertex.cpp
code/VerticesExtractor/GridTableIterator.cpp
code/VerticesExtractor/GridTable.cpp
code/SpuriousSeedAnnihilator/AttributeFetcher.cpp
code/SpuriousSeedAnnihilator/SeedFilteringWorkflow.cpp
code/SpuriousSeedAnnihilator/AnnotationFetcher.cpp
code/SpuriousSeedAnnihilator/GraphSearchResult.cpp
code/SpuriousSeedAnnihilator/NanoMerger.cpp
code/SpuriousSeedAnnihilator/SeedMergingWorkflow.cpp
code/SpuriousSeedAnnihilator/SpuriousSeedAnnihilator.cpp
code/SpuriousSeedAnnihilator/GraphExplorer.cpp
code/SpuriousSeedAnnihilator/SeedGossipSolver.cpp
code/SpuriousSeedAnnihilator/GossipAssetManager.cpp
code/SpuriousSeedAnnihilator/AnnihilationWorker.cpp
code/MachineHelper/MachineHelper.cpp
code/Surveyor/MatrixOwner.cpp
code/Surveyor/StoreKeeper.cpp
code/Surveyor/CoalescenceManager.cpp
code/Surveyor/ExperimentVertex.cpp
code/Surveyor/Mother.cpp
code/Surveyor/GenomeGraphReader.cpp
code/FusionTaskCreator/FusionWorker.cpp
code/FusionTaskCreator/FusionTaskCreator.cpp
code/Amos/Amos.cpp
code/Scaffolder/Scaffolder.cpp
code/Scaffolder/ScaffoldingEdge.cpp
code/Scaffolder/ScaffoldingVertex.cpp
code/Scaffolder/ScaffoldingLink.cpp
code/Scaffolder/SummarizedLink.cpp
code/Scaffolder/ScaffoldingAlgorithm.cpp
code/GenomeNeighbourhood/GenomeNeighbourhood.cpp
code/GenomeNeighbourhood/Neighbour.cpp
code/GenomeNeighbourhood/NeighbourPair.cpp
code/EdgePurger/EdgePurger.cpp
code/EdgePurger/EdgePurgerWorker.cpp
code/NetworkTest/NetworkTest.cpp
code/SequencesIndexer/ReadAnnotation.cpp
code/SequencesIndexer/PairedRead.cpp
code/SequencesIndexer/IndexerWorker.cpp
code/SequencesIndexer/SequencesIndexer.cpp
code/FusionData/FusionData.cpp
code/CoverageGatherer/CoverageGatherer.cpp
code/CoverageGatherer/CoverageDistribution.cpp
code/SeedingData/SeedingData.cpp
code/SeedingData/SeedWorker.cpp
code/SeedingData/PathHandle.cpp
code/SeedingData/GraphPath.cpp
RayPlatform/RayPlatform/cryptography/crypto.cpp
RayPlatform/RayPlatform/plugins/RegisteredPlugin.cpp
RayPlatform/RayPlatform/plugins/CorePlugin.cpp
RayPlatform/RayPlatform/actors/Playground.cpp
RayPlatform/RayPlatform/actors/Actor.cpp
RayPlatform/RayPlatform/profiling/Profiler.cpp
RayPlatform/RayPlatform/profiling/Derivative.cpp
RayPlatform/RayPlatform/profiling/ProcessStatus.cpp
RayPlatform/RayPlatform/profiling/TickLogger.cpp
RayPlatform/RayPlatform/profiling/TimePrinter.cpp
RayPlatform/RayPlatform/store/KeyValueStore.cpp
RayPlatform/RayPlatform/store/KeyValueStoreItem.cpp
RayPlatform/RayPlatform/store/KeyValueStoreRequest.cpp
RayPlatform/RayPlatform/memory/ReusableMemoryStore.cpp
RayPlatform/RayPlatform/memory/MyAllocator.cpp
RayPlatform/RayPlatform/memory/allocator.cpp
RayPlatform/RayPlatform/memory/RingAllocator.cpp
RayPlatform/RayPlatform/memory/ChunkAllocatorWithDefragmentation.cpp
RayPlatform/RayPlatform/memory/DefragmentationLane.cpp
RayPlatform/RayPlatform/memory/DirtyBuffer.cpp
RayPlatform/RayPlatform/memory/DefragmentationGroup.cpp
RayPlatform/RayPlatform/core/statistics.cpp
RayPlatform/RayPlatform/core/ComputeCore.cpp
RayPlatform/RayPlatform/core/MiniRank.cpp
RayPlatform/RayPlatform/core/master_modes.cpp
RayPlatform/RayPlatform/core/OperatingSystem.cpp
RayPlatform/RayPlatform/core/slave_modes.cpp
RayPlatform/RayPlatform/handlers/MessageTagExecutor.cpp
RayPlatform/RayPlatform/handlers/MasterModeExecutor.cpp
RayPlatform/RayPlatform/handlers/SlaveModeExecutor.cpp
RayPlatform/RayPlatform/scheduling/TaskCreator.cpp
RayPlatform/RayPlatform/scheduling/SwitchMan.cpp
RayPlatform/RayPlatform/scheduling/VirtualProcessor.cpp
RayPlatform/RayPlatform/files/FileReader.cpp
RayPlatform/RayPlatform/structures/StaticVector.cpp
RayPlatform/RayPlatform/communication/BufferedData.cpp
RayPlatform/RayPlatform/communication/Message.cpp
RayPlatform/RayPlatform/communication/MessageQueue.cpp
RayPlatform/RayPlatform/communication/MessagesHandler.cpp
RayPlatform/RayPlatform/communication/VirtualCommunicator.cpp
RayPlatform/RayPlatform/communication/mpi_tags.cpp
RayPlatform/RayPlatform/communication/MessageRouter.cpp
RayPlatform/RayPlatform/routing/ConnectionGraph.cpp
RayPlatform/RayPlatform/routing/Torus.cpp
RayPlatform/RayPlatform/routing/Polytope.cpp
RayPlatform/RayPlatform/routing/GraphImplementation.cpp
RayPlatform/RayPlatform/routing/GraphImplementationKautz.cpp
RayPlatform/RayPlatform/routing/GraphImplementationComplete.cpp
RayPlatform/RayPlatform/routing/GraphImplementationExperimental.cpp
RayPlatform/RayPlatform/routing/GraphImplementationRandom.cpp
RayPlatform/RayPlatform/routing/GraphImplementationDeBruijn.cpp
RayPlatform/RayPlatform/routing/GraphImplementationGroup.cpp

)

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 VERSION = 2
 PATCHLEVEL = 3
-SUBLEVEL = 0
+SUBLEVEL = 1
 EXTRAVERSION =
 NAME = Distributed Pumpkin
 
@@ -123,7 +123,7 @@
 CONFIG_FLAGS-y += -D CONFIG_MAXKMERLENGTH=$(MAXKMERLENGTH)
 
 # compile assertions
-CONFIG_FLAGS-$(CONFIG_ASSERT) += -D CONFIG_ASSERT -D ASSERT
+CONFIG_FLAGS-$(CONFIG_ASSERT) += -D CONFIG_ASSERT
 
 #compile with zlib
 CONFIG_FLAGS-$(CONFIG_HAVE_LIBZ) += -D CONFIG_HAVE_LIBZ
@@ -225,6 +225,6 @@
 
 	$(Q)mkdir $(PREFIX)/RayPlatform
 	$(Q)cp RayPlatform/AUTHORS $(PREFIX)/RayPlatform
-	$(Q)cp RayPlatform/README $(PREFIX)/RayPlatform
+	$(Q)cp RayPlatform/README.md $(PREFIX)/RayPlatform
 	$(Q)cp -r RayPlatform/Documentation $(PREFIX)/RayPlatform

=== RayPlatform/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6 )

set( CMAKE_CXX_COMPILER  mpicxx )
set( CMAKE_CXX_FLAGS "-O3 -Wall -ansi" )

include_directories( . )

set( source_files

handlers/MasterModeExecutor.cpp
handlers/SlaveModeExecutor.cpp
handlers/MessageTagExecutor.cpp
core/master_modes.cpp
core/ComputeCore.cpp
core/slave_modes.cpp
core/OperatingSystem.cpp
core/statistics.cpp
routing/GraphImplementationExperimental.cpp
routing/GraphImplementationKautz.cpp
routing/ConnectionGraph.cpp
routing/GraphImplementation.cpp
routing/GraphImplementationGroup.cpp
routing/GraphImplementationComplete.cpp
routing/GraphImplementationDeBruijn.cpp
routing/GraphImplementationRandom.cpp
routing/Hypercube.cpp
scheduling/TaskCreator.cpp
scheduling/SwitchMan.cpp
scheduling/VirtualProcessor.cpp
profiling/Derivative.cpp
profiling/TimePrinter.cpp
profiling/Profiler.cpp
profiling/TickLogger.cpp
cryptography/crypto.cpp
structures/StaticVector.cpp
memory/ReusableMemoryStore.cpp
memory/ChunkAllocatorWithDefragmentation.cpp
memory/DefragmentationGroup.cpp
memory/RingAllocator.cpp
memory/MyAllocator.cpp
memory/allocator.cpp
memory/DefragmentationLane.cpp
plugins/CorePlugin.cpp
plugins/RegisteredPlugin.cpp
communication/VirtualCommunicator.cpp
communication/MessagesHandler.cpp
communication/MessageRouter.cpp
communication/Message.cpp
communication/mpi_tags.cpp
communication/BufferedData.cpp

)

ADD_LIBRARY( RayPlatform_SHARED SHARED ${source_files})
ADD_LIBRARY( RayPlatform_STATIC STATIC ${source_files})

SET_TARGET_PROPERTIES( RayPlatform_SHARED RayPlatform_STATIC PROPERTIES OUTPUT_NAME RayPlatform )

=== RayPlatform/Makefile ===
--- 
+++ 
@@ -5,7 +5,7 @@
 
 VERSION = 2
 PATCHLEVEL = 0
-SUBLEVEL = 0
+SUBLEVEL = 1
 EXTRAVERSION =
 NAME =  Actor Nest
 
@@ -24,7 +24,7 @@
 CONFIG_ASSERT=$(ASSERT)
 
 CONFIG_FLAGS-y=
-CONFIG_FLAGS-$(CONFIG_ASSERT) += -D CONFIG_ASSERT -D ASSERT
+CONFIG_FLAGS-$(CONFIG_ASSERT) += -D CONFIG_ASSERT
 CONFIG_FLAGS=$(CONFIG_FLAGS-y)
 
 # inference rule

=== code/Amos/Makefile ===
Amos-y += code/Amos/Amos.o

obj-y += $(Amos-y)

=== code/CoverageGatherer/Makefile ===
CoverageGatherer-y += code/CoverageGatherer/CoverageGatherer.o 
CoverageGatherer-y += code/CoverageGatherer/CoverageDistribution.o 

obj-y += $(CoverageGatherer-y)

=== code/EdgePurger/Makefile ===
EdgePurger-y += code/EdgePurger/EdgePurger.o
EdgePurger-y += code/EdgePurger/EdgePurgerWorker.o

obj-y += $(EdgePurger-y)

=== code/Example/Makefile ===
Example-y += code/Example/Example.o

obj-y += $(Example-y)

=== code/FusionData/Makefile ===
FusionData-y += code/FusionData/FusionData.o 

obj-y += $(FusionData-y)

=== code/GeneOntology/Makefile ===
GeneOntology-y += code/GeneOntology/KeyEncoder.o
GeneOntology-y += code/GeneOntology/GeneOntology.o

obj-y += $(GeneOntology-y)

=== code/GenomeNeighbourhood/Makefile ===
GenomeNeighbourhood-y += code/GenomeNeighbourhood/GenomeNeighbourhood.o
GenomeNeighbourhood-y += code/GenomeNeighbourhood/Neighbour.o
GenomeNeighbourhood-y += code/GenomeNeighbourhood/NeighbourPair.o

obj-y += $(GenomeNeighbourhood-y)

=== code/JoinerTaskCreator/Makefile ===
JoinerTaskCreator-y += code/JoinerTaskCreator/JoinerWorker.o 
JoinerTaskCreator-y += code/JoinerTaskCreator/JoinerTaskCreator.o

obj-y += $(JoinerTaskCreator-y)

=== debian/changelog ===
ray (2.3.1-9) unstable; urgency=medium

  [ Helmut Grohne ]
  * Fix FTCBFS: Compute mpi compile flags using pkgconf. (Closes: #1085491)

  [ Andreas Tille ]
  * Standards-Version: 4.7.0 (routine-update)

 -- Andreas Tille <tille@debian.org>  Mon, 02 Dec 2024 16:37:51 +0100

ray (2.3.1-8) unstable; urgency=medium

  * Team upload.
  * Packaging update
  * Standards-Version: 4.6.2 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Use secure URI in Homepage field.
  * Fix spacing typo in debian/rules
  * Apply multi-arch hints.
    + ray-doc: Add Multi-Arch: foreign.
  * watch file standard 4 (routine-update)
  * d/rules: Clean REFIX directory and RayPlatform/README (Closes: #1047580)

 -- Lance Lin <lq27267@gmail.com>  Wed, 06 Dec 2023 20:16:19 +0700

ray (2.3.1-7) unstable; urgency=medium

  * Use 2to3 to port to Python3
    Closes: #945704
  * debhelper-compat 12
  * Standards-Version: 4.4.1
  * Remove trailing whitespace in debian/copyright
  * autopkgtest: s/ADTTMP/AUTOPKGTEST_TMP/g
  * Use secure URI in debian/watch.
  * Remove obsolete fields Name from debian/upstream/metadata.
  * Fix day-of-week for changelog entries 2.1.0-1.

 -- Andreas Tille <tille@debian.org>  Mon, 02 Dec 2019 12:51:58 +0100

ray (2.3.1-6) unstable; urgency=medium

  * Team upload

  [ Nadiya Sitdykova ]
  * Get rid of ssh dependency
  * Allow mpi run without ssh dependency

  [ Graham Inggs ]
  * Allow node oversubscription in autopkgtest
  * Switch to debhelper 11
  * Use HTTPS for copyright format
  * Update Vcs-* URIs for move to salsa.debian.org
  * Remove trailing whitespace from d/changelog, d/control and d/rules
  * Bump Standards-Version to 4.1.4, no further changes

 -- Graham Inggs <ginggs@debian.org>  Thu, 17 May 2018 13:03:55 +0000

ray (2.3.1-5) unstable; urgency=medium


  [ Nadiya Sitdykova ]
  * Add autopkgtest test-suite
  * Add missing ssh dependency

  [ Andreas Tille ]
  * debhelper 10
  * Standards-Version: 4.0.0 (no changes needed)

 -- Nadiya Sitdykova <rovenskasa@gmail.com>  Thu, 27 Jul 2017 23:21:43 -0400

ray (2.3.1-4) unstable; urgency=medium

  * Team upload.
  * Enforce stable sort order for linking to make build reproducible.
  * Fix hardening by using CPPFLAGS etc.

 -- Sascha Steinbiss <sascha@steinbiss.name>  Wed, 18 May 2016 21:06:31 +0000

ray (2.3.1-3) unstable; urgency=medium

  [ Sascha Steinbiss ]
  * Team upload.
  * Fix FTBFS with GCC6.
    Closes: #811633

  [ Andreas Tille ]
  * cme fix dpkg-control
  * Better hardening

 -- Sascha Steinbiss <sascha@steinbiss.name>  Fri, 08 Apr 2016 16:03:18 +0000

ray (2.3.1-2) unstable; urgency=medium

  * Team upload.
  * Fix FTBFS on s390x. Link against pthread.

 -- Anton Gladky <gladk@debian.org>  Wed, 30 Dec 2015 20:13:33 +0100

ray (2.3.1-1) unstable; urgency=medium

  * New upstream version
  * cme fix dpkg-control (including shortened synopsis)
  * d/copyright:
     - make sure all files are included in copyright statement
       and chose more strict license (GPL-3) for the missing files
     - add separate section for debian/*

 -- Andreas Tille <tille@debian.org>  Thu, 25 Sep 2014 16:53:37 +0200

=== debian/control ===
Source: ray
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Sébastien Boisvert <sebastien.boisvert.3@ulaval.ca>,
           Andreas Tille <tille@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               zlib1g-dev,
               libbz2-dev,
               mpi-default-dev,
               pkgconf,
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/med-team/ray
Vcs-Git: https://salsa.debian.org/med-team/ray.git
Homepage: https://denovoassembler.sourceforge.net/
Rules-Requires-Root: no

Package: ray
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         mpi-default-bin
Description: de novo genome assemblies of next-gen sequencing data
 Ray is a parallel software that computes de novo genome assemblies with
 next-generation sequencing data.
 Ray is written in C++ and can run in parallel on numerous interconnected
 computers using the message-passing interface (MPI) standard.
 Included:
  - Ray de novo assembly of single genomes
  - Ray Méta de novo assembly of metagenomes
  - Ray Communities microbe abundance + taxonomic profiling
  - Ray Ontologies gene ontology profiling

Package: ray-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Multi-Arch: foreign
Description: documentation for ray parallel de novo genome assembler
 Ray is a parallel software that computes de novo genome assemblies with
 next-generation sequencing data.
 Ray is written in C++ and can run in parallel on numerous interconnected
 computers using the message-passing interface (MPI) standard.
 .
 This package includes documentation files.

Package: ray-extra
Architecture: all
Depends: ${misc:Depends},
         r-base-core,
         python3
Description: Scripts and XSL sheets for post-processing for ray
 Ray is a parallel software that computes de novo genome assemblies with
 next-generation sequencing data.
 Ray is written in C++ and can run in parallel on numerous interconnected
 computers using the message-passing interface (MPI) standard.
 .
 This package contains scripts and XSL sheets for post-processing.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/dpkg/buildtools.mk

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CXXFLAGS_MAINT_APPEND = $(shell $(PKG_CONFIG) --cflags mpi-c)
export DEB_LDFLAGS_MAINT_APPEND = $(shell $(PKG_CONFIG) --libs mpi-c)

%:
	dh $@

override_dh_auto_clean:
	dh_auto_clean -- CXXFLAGS="$(CXXFLAGS)" HAVE_LIBZ=y HAVE_LIBBZ2=y
	rm -rf install-prefix REFIX
	rm -f README.Ray README.RayPlatform RayPlatform/README

override_dh_auto_build:
	dh_auto_build -- MPICXX='$(CXX)' CXXFLAGS="$(CXXFLAGS)" DEBLDFLAGS="$(LDFLAGS) -lpthread" HAVE_LIBBZ2=y HAVE_LIBZ=y
	#Rename 2 docs to make more sence in package context
	cp README.md README.Ray
	cp RayPlatform/README.md README.RayPlatform
	cp RayPlatform/README.md RayPlatform/README

=== debian/watch ===
version=4
https://sf.net/denovoassembler/Ray-v?(\d[\d\.]+)\.tar\.bz2

## ray cli-1.0.1

=== Makefile ===
.PHONY: all clean build install test publish uninstall dist-clean

PACKAGE_NAME := ray-cli
DIST_DIR := dist
TEST_DIR := .pytest_cache .pytype .tox
WHEEL := $(DIST_DIR)/*.whl

all: install

build: dist-clean
	@echo "Building package..."
	uv build

install: build
	@echo "Installing $(PACKAGE_NAME) via uv..."
	uv tool install --force $(WHEEL)

test:
	@echo "Running tests with tox..."
	tox

publish: test build
	@echo "Publishing $(PACKAGE_NAME) to PyPI..."
	uv publish --token "$$(security find-generic-password -w -s pypi-token)"

clean: dist-clean test-clean uninstall

uninstall:
	@echo "Uninstalling $(PACKAGE_NAME) via uv..."
	uv tool uninstall $(PACKAGE_NAME)

dist-clean:
	@echo "Cleaning distribution files..."
	rm -rf $(DIST_DIR)

test-clean:
	@echo "Cleaning test files..."
	rm -rf $(TEST_DIR)
